src/Entity/Article.php
<?php

namespace App\Entity;

use App\Repository\ArticleRepository;
use Doctrine\Common\Collections\ArrayCollection;
use Doctrine\Common\Collections\Collection;

use Doctrine\Common\Collections\Criteria;
use Gedmo\Mapping\Annotation as Gedmo;
use Doctrine\ORM\Mapping as ORM;
use Gedmo\Timestampable\Traits\TimestampableEntity;

/**
 * @ORM\Entity(repositoryClass=ArticleRepository::class)
 */
class Article
{
    use TimestampableEntity;

    /**
     * @ORM\Id
     * @ORM\GeneratedValue
     * @ORM\Column(type="integer")
     */
    private $id;

    /**
     * @ORM\Column(type="string", length=255)
     */
    private $title;

    /**
     * @ORM\Column(type="string", length=100, unique=true)
     * @Gedmo\Slug(fields={"title"})
     */
    private $slug;

    /**
     * @ORM\Column(type="text", nullable=true)
     */
    private $content;

    /**
     * @ORM\Column(type="datetime", nullable=true)
     */
    private $publishedAt;

    /**
     * @ORM\Column(type="string", length=255)
     */
    private $category;

    /**
     * @ORM\Column(type="integer")
     */
    private $viewsCount = 0;

    /**
     * @ORM\Column(type="string", length=255, nullable=true)
     */
    private $imageFilename;

    /**
     * @ORM\Column(type="string", length=255)
     */
    private $author;

    /**
     * @ORM\OneToMany(targetEntity=Comment::class, mappedBy="article",fetch="EXTRA_LAZY")
     * @ORM\OrderBy({"createdAt" = "DESC"})
     */
    private $comments;

    /**
     * @ORM\ManyToMany(targetEntity=Tag::class, inversedBy="articles")
     */
    private $tags;

    public function __construct()
    {
        $this->comments = new ArrayCollection();
        $this->tags = new ArrayCollection();
    }

    public function getId(): ?int
    {
        return $this->id;
    }

    public function getTitle(): ?string
    {
        return $this->title;
    }

    public function setTitle(string $title): self
    {
        $this->title = $title;

        return $this;
    }

    public function getSlug(): ?string
    {
        return $this->slug;
    }

    public function setSlug(string $slug): self
    {
        $this->slug = $slug;

        return $this;
    }

    public function getContent(): ?string
    {
        return $this->content;
    }

    public function setContent(?string $content): self
    {
        $this->content = $content;

        return $this;
    }

    public function getPublishedAt(): ?\DateTimeInterface
    {
        return $this->publishedAt;
    }

    public function setPublishedAt(?\DateTimeInterface $publishedAt): self
    {
        $this->publishedAt = $publishedAt;

        return $this;
    }

    public function getCategory(): ?string
    {
        return $this->category;
    }

    public function setCategory(string $category): self
    {
        $this->category = $category;

        return $this;
    }

    public function getViewsCount(): ?int
    {
        return $this->viewsCount;
    }

    public function setViewsCount(int $viewsCount): self
    {
        $this->viewsCount = $viewsCount;

        return $this;
    }

    public function getImageFilename(): ?string
    {
        return $this->imageFilename;
    }

    public function setImageFilename(?string $imageFilename): self
    {
        $this->imageFilename = $imageFilename;

        return $this;
    }

    public function getAuthor(): ?string
    {
        return $this->author;
    }

    public function setAuthor(string $author): self
    {
        $this->author = $author;

        return $this;
    }

    public function getImagePath(){
        return "images/posts/".$this->getImageFilename();
    }

    public function incrementViews(): self
    {
        $this->viewsCount = $this->viewsCount + 1;

        return $this;
    }

    /**
     * @return Collection|Comment[]
     */
    public function getComments(): Collection
    {
        return $this->comments;
    }

    /**
     * @return Collection|Comment[]
     */
    public function getNonDeletedComments(): Collection
    {
        $criteria = ArticleRepository::createNonDeletedCriteria();

        return $this->comments->matching($criteria);
    }

    public function addComment(Comment $comment): self
    {
        if (!$this->comments->contains($comment)) {
            $this->comments[] = $comment;
            $comment->setArticle($this);
        }

        return $this;
    }

    public function removeComment(Comment $comment): self
    {
        if ($this->comments->removeElement($comment)) {
            // set the owning side to null (unless already changed)
            if ($comment->getArticle() === $this) {
                $comment->setArticle(null);
            }
        }

        return $this;
    }

    /**
     * @return Collection|Tag[]
     */
    public function getTags(): Collection
    {
        return $this->tags;
    }

    public function addTag(Tag $tag): self
    {
        if (!$this->tags->contains($tag)) {
            $this->tags[] = $tag;
        }

        return $this;
    }

    public function removeTag(Tag $tag): self
    {
        $this->tags->removeElement($tag);

        return $this;
    }
}

src/Controller/ArticleController.php
<?php


namespace App\Controller;

use App\Entity\Article;
use App\Repository\ArticleRepository;
use Doctrine\ORM\EntityManagerInterface;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\Routing\Annotation\Route;

class ArticleController extends AbstractController
{
    /**
     * @Route("/",name="article.index")
     */
    public function index(ArticleRepository $repository){

        $articles = $repository->findByLatestPublished();

        return $this->render("article/index.html.twig",[
            'articles' => $articles,
        ]);
    }

    /**
     * @Route("/article/{slug}", name="article.show")
     */
    public function show(Article $article, EntityManagerInterface $em){

        $article->incrementViews();
        $em->flush();

        return $this->render("article/show.html.twig",[
            'article' => $article
        ]);
    }
}

templates/article/index.html.twig
{% extends "base.html.twig" %}

{% block body %}
    <div class="posts">
        <div class="posts-inner list-layout">

            {% for article in articles %}
                <article class="post">
                    <div class="post-media" style="background-image: url({{ asset(article.imagePath) }})">
                        <a href="{{ path('article.show',{slug:article.slug}) }}">
                            <img src="{{ asset(article.imagePath) }}" alt="{{ article.title }}">
                        </a>
                    </div>
                    <div class="post-content">
                        <div class="post-header">
                            <h2 class="title">
                                <a href="{{ path('article.show',{slug:article.slug}) }}">{{ article.title }}</a>
                            </h2>

                            <!-- Post Details -->
                            <div class="post-details">
                                <div class="post-cat">
                                    <a href="#">{{ article.category }}</a>
                                </div>
                                <a href="#" class="post-date"><span>{{ article.publishedAt ? article.publishedAt|ago }}</span></a>
                                <div class="post-details-child">
                                    <a href="#" class="post-views">{{ article.viewsCount }}</a>
                                    <a href="#" class="post-comments">{{ article.nonDeletedComments|length }}</a>
                                    <div class="post-share-icon">
                                        <ul>
                                            <li><a href="#"><i class="fa fa-facebook"></i><span>Facebook</span></a></li>
                                            <li><a href="#"><i class="fa fa-google"></i><span>Google Plus</span></a></li>
                                            <li><a href="#"><i class="fa fa-twitter"></i><span>Twitter</span></a></li>
                                            <li><a href="#"><i class="fa fa-behance"></i><span>Behance</span></a></li>
                                            <li><a href="#"><i class="fa fa-dribbble"></i><span>Dribbble</span></a></li>
                                        </ul>
                                    </div>
                                </div>
                            </div>
                            <!-- End Post Details -->
                        </div>
                        <!-- The Content -->
                        <div class="the-excerpt">
                            <p>Morbi leo enim, laoreet eget urna id, ullamcorper condimentum urna. Curabitur accumsan sem et nisi ultricies porttitor...
                            </p>
                        </div>
                        <!-- End The Content -->
                        <div class="read-more">
                            <a href="{{ path('article.show',{slug:article.slug}) }}">Continue Reading ...</a>
                        </div>
                    </div>

                </article>
            {% endfor %}

        </div>

    </div>
{% endblock %}

templates/article/show.html.twig
{% extends 'base.html.twig' %}

{% block body %}
    <div class="posts">
        <div class="posts-inner">
            <article class="post">
                <div class="post-header">
                    <h2 class="title"><span>{{ article.title }}</span></h2>

                    <!-- Post Details -->
                    <div class="post-details">
                        <div class="post-cat">
                            <a href="#">{{ article.category }}</a>
                        </div>
                        <a href="#" class="post-date"><span>{{ article.publishedAt ? article.publishedAt|ago : 'unpublished' }}</span></a>
                        <div class="post-details-child">
                            <a href="#" class="post-views">{{ article.viewsCount }} views</a>
                            <a href="#" class="post-comments">{{ article.comments|length }} Comments</a>
                        </div>
                    </div>
                    <!-- End Post Details -->
                </div>
                <div class="post-media">
                    <img src="{{ asset(article.imagePath) }}" alt="Post">
                </div>
                <div class="post-content">

                    <!-- The Content -->
                    <div class="the-excerpt">
                        {{ article.content|cached_markdown }}
                    </div>
                    <!-- End The Content -->

                    <div class="post-tags">
                        <strong>Tags: </strong>
                        <ul>
                            {% for tag in article.tags %}
                                <li><a href="#">{{ tag.title }}</a></li>
                            {% endfor %}
                        </ul>
                    </div>
                    <div class="post-author">
                        Writed by  <a href="#">{{ article.author }}</a>
                    </div>
                </div>

            </article>
        </div>

        <!-- Pagination -->
        <div class="pagination-wrap">

            <div class="older">
                <a href="#" title="The living room is too small">Prev Post <i class="fa fa-angle-double-right"></i></a>
                <h2 class="title">
                    <a href="#">The living room is too small</a>
                </h2>
            </div>
            <div class="newer">
                <a href="#" title="They have originality "><i class="fa fa-angle-double-left"></i> Next Post</a>
                <h2 class="title">
                    <a href="#">They have originality </a>
                </h2>
            </div>
        </div>
        <!-- End Pagination -->

        <!-- Related Posts -->
        <div id="related-posts">
            <h2 class="title"><span>Related Posts</span></h2>
            <div class="row">
                <div class="col-sm-6">
                    <div class="post">
                        <div class="post-media" style="background-image: url(images/posts/4.jpg)">
                            <a href="single.html">
                                <img src="images/posts/4.jpg" alt="Image">
                            </a>
                        </div>
                        <div class="post-entry">
                            <h3 class="title">
                                <a href="single.html">Living Lagom in Sweden: An Interview With Lola Akerstrom</a>
                            </h3>
                            <div class="post-details">
                                <a href="#" class="post-date"><span>Aug 06, 2018</span></a>
                            </div>
                        </div>
                    </div>
                </div>
                <div class="col-sm-6">
                    <div class="post">
                        <div class="post-media" style="background-image: url(images/posts/2.jpg)">
                            <a href="single.html">
                                <img src="images/posts/2.jpg" alt="Image">
                            </a>
                        </div>
                        <div class="post-entry">
                            <h3 class="title">
                                <a href="single.html">Living Lagom in Sweden: An Interview With Lola Akerstrom</a>
                            </h3>
                            <div class="post-details">
                                <a href="#" class="post-date"><span>Aug 06, 2018</span></a>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
        <!-- Related Posts -->

        <!-- Comments -->
        <div id="comments">
            <h2 class="title"><span>{{ article.nonDeletedComments|length }} Comments</span></h2>
            <div class="comments-inner">
                <ul class="comment-list">

                    {% for comment in article.nonDeletedComments %}
                        <li class="comment">
                            <div class="comment-body">
                                <div class="comment-head">
                                    <div class="comment-avatar">
                                        <img alt="avatar" src="images/avatar-150px.jpg">
                                    </div>
                                    <div class="comment-info">
                                        <h5 class="title">{{ comment.authorName }}</h5>
                                        <span class="comment-date">{{ comment.createdAt|ago }}</span>
                                        {% if(comment.isdeleted) %}
                                            <span class="comment-date" style="color: red;">Deleted</span>
                                        {% endif %}
                                    </div>
                                </div>
                                <div class="comment-context">
                                    <p>{{ comment.content }}</p>
                                    <div class="reply">
                                        <span class="comment-reply"><a class="comment-reply-link" href="#">Reply</a></span>
                                    </div>
                                </div>
                            </div>
                        </li>
                    {% endfor %}
                </ul>
            </div>

            <!-- Respond -->
            <div id="respond" class="comment-respond">
                <h2 class="title"><span>Leave a Reply</span></h2>
                <form action="#" method="post" class="contact">
                    <div class="contact-item">
                        <label>Your Name *</label>
                        <input name="author" value="" type="text">
                    </div>
                    <div class="contact-item">
                        <label>Your Email *</label>
                        <input name="email" value="" type="email">
                    </div>
                    <div class="contact-item">
                        <label>Website URL</label>
                        <input id="url" name="url" value="" type="text">
                    </div>
                    <div class="contact-item">
                        <label>Your Comment *</label>
                        <textarea name="comment"></textarea>
                    </div>
                    <div class="contact-item form-submit">
                        <input name="submit" type="submit" id="submit" class="submit" value="Submit">
                    </div>
                </form>
            </div><!-- #respond -->
            <!-- End Respond -->
        </div>
        <!-- End Comments -->
    </div>
{% endblock %}